#!/usr/bin/python

##############################################
# Rename and symlink ONL installers
# Copyright Steven Noble (steven.noble@bigswitch.com)
##############################################

import glob
import itertools
import os
import re
import sys

latest = sys.argv[1]

a = 0
i = 0
o = 0

ARCH = ["AMD64","ARMEL","PPC","ARM64","ARMHF"]
OS = ["OS8","OS9"]
INST = ["INSTALLED","SWI"]

class GOAT(object):

    latest = sys.argv[1]
    def _remove_latest_rename(self, latest):
        if os.path.exists("latest"):
            os.remove("latest") # remove latest symlink
            for f in glob.glob("*.installer"):
                os.remove(f) # remove *.installer symlinks

        for fname in os.listdir(latest):
            new_name = fname.replace('_','-'); # replace _ with -
            os.rename(latest + fname, latest + new_name)

        os.symlink(latest,"latest")

    def _symlink_files(self, latest, a, i, o):
        for fname in os.listdir(latest):
            if ARCH[a] in fname and INST[i] in fname and OS[o] in fname:
                  if o == 0: DEB = "DEB8" # fix DEB names from OS names
                  elif o == 1: DEB = "DEB9"
                  dest = ("latest-"+ DEB +"-"+ ARCH[a] +"-"+ INST[i]+".installer") # create symlink name for latest versions of code
                  os.symlink(latest + fname, dest) # symlink latest codejj

    def _run_symlink(self, latest):
         images =  itertools.product([0, 1, 2, 3, 4], [0, 1], [0, 1])
         for a, i, o in images: # iterate through all permutations
             shoe._symlink_files(latest, a, i, o)

if __name__ == '__main__':
    shoe = GOAT()
    shoe._remove_latest_rename(latest)
    shoe._run_symlink(latest)
